/**
********************************************************************************
* @file       M6678E_EFUSE.h
* @brief      ʵM66x EFUSEõĸֽӿںͼĴ궨塣
* @version    V1.0
* @date       2024.1.3
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef   _M6678E_EFUSE_H_
#define   _M6678E_EFUSE_H_

#include "stdint.h"
#include <stdio.h>
#include <string.h>


/***************EFUSE ӿں***************************************************/
void EFUSE_Program(uint32_t addr , uint8_t data);
void EFUSE_Read(uint32_t addr , uint8_t *data);
void delay(int cnt);

/***************EFUSE Ĵַ*******************************************************/
#define M6678E_EFUSE_BASE              0x08028000			/*	M6678E_EFUSEĴַ	*/
#define EFUSE_KEY			 	 	   0x00756989			/*	ʹEFUSEдKEYֵ		*/

/*	GMAC0/GMAC1ڲDMAģĴ	*/
typedef struct
{
	volatile uint32_t AGENT_ADDR;				/*	/дַĴ 0x08028000+0x0	*/
	volatile uint32_t AGENT_DATA;				/*	ݼĴ		0x08028000+0x4	*/
	volatile uint32_t RSVD0[2];					/*	ַ			0x08028000+0x8,+0xC*/
	volatile uint32_t READ_DATA;				/*	ݼĴ		0x08028000+0x10	*/
	volatile uint32_t PROGRAM_DATA;				/*	ʹܱ̼Ĵ		0x08028000+0x14*/
}EFUSERegs;


#define EFUSE_ADDR_MAX   512						/*M6678E_EFUSEΪ512Уռ仮ֿԲοֲ*/
#define EFUSE_START_LINE  16
#define EFUSE_END_LINE    22					   	/*EFUSE_START_LINE д EFUSE_END_LINE*/

#endif
