/** 
********************************************************************************
* @file       M6678E_Reset.h
* @brief      M6678E λؽӿںͼĴ궨塣
* @version    V1.0
* @date       2024.1.17
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef _M6678E_RESET_H_
#define _M6678E_RESET_H_

#define WDT0ISOLATION  0x09020080
#define RSTTYPE        *(volatile unsigned int *)0x090200A8
#define PERRSTTYPE     *(volatile unsigned int *)0x090200AC
#define RSTTYPE_SRC    *(volatile unsigned int *)0x090200B0
#define RSTTRIGGER     *(volatile unsigned int *)0x090200A4
#define DDR_RESET      *(volatile unsigned int *)0x090200B4
#define KICK0          *(volatile unsigned int *)0x09000038
#define KICK1          *(volatile unsigned int *)0x0900003C

extern void  WatchDog_Reset_Config(unsigned int WatchDog_Numb , unsigned int RSTEN );
extern void  Reset_Trigger(unsigned int Trigger_Numb);
extern void  Get_Reset_State();
extern void  Get_Reset_Source();
#endif /* _M6678E_Reset_H_ */
