/**
********************************************************************************
* @file       M6678E_EFUSE.c
* @brief      EFUSEĽӿں
* @version    V1.0
* @date       2023.9.21
* @attention
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include <string.h>
#include "M6678E_EFUSE.h"
/** @addtogroup EFUSE_FUNCTION
 @{ */

#define pEfuse      ((EFUSERegs *)M6678E_EFUSE_BASE)			/*	EFUSEĴ		*/


/**
********************************************************************************
 *   @n@b EFUSE_Program(unsigned int addr , unsigned char data)
 *
 *   @b ܣ
 *   @n EFUSEӦкaddrдӦdata
 *
 *   @b βΣ
 *   @verbatim
 *       addr	Ҫдĵַк
 *       data	Ҫд
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void EFUSE_Program(unsigned int addr , unsigned char data)
{
	if((addr > EFUSE_ADDR_MAX))
		printf(" EFUSE addr is invalid .\n");

	pEfuse->AGENT_ADDR = addr;

	pEfuse->AGENT_DATA = data;

	pEfuse->PROGRAM_DATA = EFUSE_KEY;	/*	ʹEFUSEдKEYֵ		*/

	return ;
}
/**
********************************************************************************
 *   @n@b void EFUSE_Read(unsigned int addr , unsigned char *data)
 *
 *   @b ܣ
 *   @n EFUSEӶӦкaddrȡӦdata
 *
 *   @b βΣ
 *   @verbatim
 *       addr	Ҫȡĵַк
 *       data	ȡ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void EFUSE_Read(unsigned int addr , unsigned char *data)
{

	if((addr > EFUSE_ADDR_MAX))
		printf(" EFUSE addr is invalid .\n");

	pEfuse->AGENT_ADDR = addr;

	*data = pEfuse->READ_DATA;

}

/*ʱ*/
void delay(int cnt)
{
	int i=0;
	for(i=0; i<cnt; i++)
		asm(" NOP 5 ");
}

unsigned char tEfuseData[EFUSE_ADDR_MAX];		/*	EFUSEȡ 		*/
unsigned char EfuseData [EFUSE_ADDR_MAX] =
{ /*	ҪEFUSEд(ֻдҪдĲ֣0д)	    */
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:0~15	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:16~31	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:32~47	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:48~63	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:64~79	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:80~95	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:96~111*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,/*	EfuseLine:112~127*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:128~143*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:144~159*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:160~175*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:176~191*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:192~207*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:208~223*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,/*	EfuseLine:224~239*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,/*	EfuseLine:240~255*/

	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+0~15	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+16~31	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+32~47	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+48~63	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+64~79	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+80~95	*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+96~111*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+112~127*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+128~143*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+144~159*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+160~175*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+176~191*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+192~207*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+208~223*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0, /*	EfuseLine:255+224~239*/
	0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0	 /*	EfuseLine:255+240~255*/
};
/*	EfuseLineΪ512УÿΪ 8 bit(߿дFF-FF-FF-FF...)޸Ҫֵ		*/
