/*
*	M6678E TPS ļ
*	M6678E ʹõ¶ȴͺΪS14NSFPVT
*	¶ȲΧ-40~125
*
*	First Writer: WenJoy
*/

#include "M6678E_TSC.h"
/** @addtogroup TSC_FUNCTION
 @{ */
 
void TPS_delay(uint32_t delay_time)
{
	uint32_t x,y;

	for(x=0;x<delay_time;x++)
	{	for(y=0;y<delay_time;y++)
		{
			asm(" nop 1 ");
		}
	}
}

// TPSʼ
void PVT_Init(void)
{
	uint8_t loop;
	// PVTϵѡ¶ȴģʽ
	for(loop=0;loop<6;loop++)
	{
		// λ
		*(uint32_t*)(TPS_BASE + TPS0_MODE + loop*0x100) = 0x0;	// RB=0
		TPS_delay(1250);
		// ϵ
		*(uint32_t*)(TPS_BASE + TPS0_MODE + loop*0x100) = 0xB;	// ģʽ RB=1 PD=1 =1
//		*(uint32_t*)(TPS_BASE + TPS0_MODE + loop*0x100) = 0xA;	// ѹģʽ
		TPS_delay(1250);
		*(uint32_t*)(TPS_BASE + TPS0_MODE + loop*0x100) = 0x3;	// RBź
		TPS_delay(1250);
		*(uint32_t*)(TPS_BASE + TPS0_MODE + loop*0x100) = 0xB;	// RBź
		TPS_delay(1250);

	}
}

// PVTУ׼
void PVT_FIX(uint32_t fix_num)
{
	uint8_t loop;

	for(loop=0;loop<6;loop++)
	{
		*(uint32_t*)(TPS_BASE + TPS0_TRIM + loop*0x100) = fix_num;	// У׼Ĵдֵ
		TPS_delay(10);
	}
}

void PPS_Init(void)
{
	uint8_t loop;
	// PVTϵѡ¶ȴģʽ
	for(loop=0;loop<6;loop++)
	{
		// λ
		*(uint32_t*)(TPS_BASE + PPS0_SVT_RB + loop*0x100) = 0x0;	// RBź
		*(uint32_t*)(TPS_BASE + PPS0_LVT_RB + loop*0x100) = 0x0;	// RBź
		*(uint32_t*)(TPS_BASE + PPS0_ULVT_RB + loop*0x100) = 0x0;	// RBź
		TPS_delay(1250);
		// ϵ
		*(uint32_t*)(TPS_BASE + PPS0_SVT_PU + loop*0x100) = 0x1;	// ϵ PU
		*(uint32_t*)(TPS_BASE + PPS0_LVT_PU + loop*0x100) = 0x1;	// ϵ
		*(uint32_t*)(TPS_BASE + PPS0_ULVT_PU + loop*0x100) = 0x1;	// ϵ
		TPS_delay(1250);
		*(uint32_t*)(TPS_BASE + PPS0_SVT_RB + loop*0x100) = 0x1;	// RBź
		*(uint32_t*)(TPS_BASE + PPS0_LVT_RB + loop*0x100) = 0x1;	// RBź
		*(uint32_t*)(TPS_BASE + PPS0_ULVT_RB + loop*0x100) = 0x1;	// RBź
	}
}

void PVT_Alarm_Init(uint32_t Alarm_num)
{
	*(uint32_t*)(TPS_BASE + TPS_TGATE) = Alarm_num;	// þ津¶ֵ
	*(uint32_t*)(TPS_BASE + TPS_INTEN) = 0x3F;		// ʹ¶жϼĴ
}

void PVT_Alarm_check(void)
{
	uint8_t check_num = 0;
	check_num = *(uint32_t*)(TPS_BASE + TPS_TGATE);
	
	if( check_num != 0 )
	{
		printf("temperature alarm!\n");
		check_num = 0;
	}
	
}

// ͨI2CдTPS
void TPS_I2C_Write(I2C_TypeDef *I2C_Dev, uint8_t Slave_Address)
{
	uint8_t Loopcount = 0;
	// ʼ
	uint8_t TPS_Send_buf[64] = {0};

	// I2CؼĴ
	I2C_Dev->I2CSTR |= I2C_Dev->I2CSTR;	// ״̬Ĵ
	I2C_Dev->I2CMDR = (1<<14)|(1<<10)|(1<<9)|(1<<13)|(1<<11);	// FREE MST TRX
	I2C_Dev->I2CSAR = Slave_Address;	// ӻַ
	I2C_Dev->I2CCNT = 64;		// ͵
	I2C_Dev->I2CMDR |= (1<<5);			// ʹI2C

	// TPS_I2CӻַĴ
	*(uint32_t*)(TPS_BASE + TPS_I2COAR) = Slave_Address;

/***********************************ӻд***********************************/

	// дӻַ
	TPS_Send_buf[0] = Slave_Address;
	for(Loopcount = 0; Loopcount < 6; Loopcount++)
	{
		// ִз
		I2C_Dev->I2CDXR = TPS_Send_buf[Loopcount];
		while(!(I2C_Dev->I2CSTR & 0x10));	// ȴ
		I2C_Dev->I2CSTR &= 0x10;			// ñ־λ I2C_DXRдʱԶ
		// дӦͨ
		TPS_Send_buf[Loopcount+1] |= Loopcount<<4;
	}

}

// PVT¶ȶȡ
void PVT_temperture_read(void)
{
	uint8_t loop;
	uint32_t PVT_Dout0 = 0,PVT_Dout1 = 0,PVT_Dout2 = 0,PVT_Dout3 = 0,PVT_Dout4 = 0,PVT_Dout5 = 0;
	uint32_t PVT_Dout = 0;
	double PVT_TS = 0;

	// PVTĴжȡ ƽֵ
	for(loop=0;loop<100;loop++)
	{
		PVT_Dout0 += *(uint32_t*)(TPS_BASE + TPS0_DOUT);
		PVT_Dout1 += *(uint32_t*)(TPS_BASE + TPS1_DOUT);
		PVT_Dout2 += *(uint32_t*)(TPS_BASE + TPS2_DOUT);
		PVT_Dout3 += *(uint32_t*)(TPS_BASE + TPS3_DOUT);
		PVT_Dout4 += *(uint32_t*)(TPS_BASE + TPS4_DOUT);
		PVT_Dout5 += *(uint32_t*)(TPS_BASE + TPS5_DOUT);
		TPS_delay(100);
	}

	PVT_Dout = (PVT_Dout0+PVT_Dout1+PVT_Dout2+PVT_Dout3+PVT_Dout4+PVT_Dout5)/600;
	printf("PVT0 Read Data:%d \n",PVT_Dout0/100);
	printf("PVT1 Read Data:%d \n",PVT_Dout1/100);
	printf("PVT2 Read Data:%d \n",PVT_Dout2/100);
	printf("PVT3 Read Data:%d \n",PVT_Dout3/100);
	printf("PVT4 Read Data:%d \n",PVT_Dout4/100);
	printf("PVT5 Read Data:%d \n",PVT_Dout5/100);
	printf("PVT average Read Data:%d \n",PVT_Dout);

	if(PVT_Dout>= 2705)
	{
		PVT_TS = ( (double)PVT_Dout - 2705) /2.2632;
		printf("Tempture sensing : %.2f \n\n",PVT_TS);
	}
	else

	{
		PVT_TS = ( 2705 - (double)PVT_Dout) /2.2632;
		printf("Tempture sensing : -%.2f \n\n",PVT_TS);
	}

}

// PPS¶ȶȡ
void PPS_temperture_read(void)
{
	uint8_t loop;
	uint32_t SVT_Dout0 = 0,SVT_Dout1 = 0,SVT_Dout2 = 0,SVT_Dout3 = 0,SVT_Dout4 = 0,SVT_Dout5 = 0;
	uint32_t LVT_Dout0 = 0,LVT_Dout1 = 0,LVT_Dout2 = 0,LVT_Dout3 = 0,LVT_Dout4 = 0,LVT_Dout5 = 0;
	uint32_t ULVT_Dout0 = 0,ULVT_Dout1 = 0,ULVT_Dout2 = 0,ULVT_Dout3 = 0,ULVT_Dout4 = 0,ULVT_Dout5 = 0;
	uint32_t SVT_AVAout = 0,LVT_AVAout = 0,ULVT_AVAout = 0;
	
	// PVTĴжȡ ƽֵ
	for(loop=0;loop<100;loop++)
	{
		SVT_Dout0 += *(uint32_t*)(TPS_BASE + PPS0_SVT_DOUT);
		SVT_Dout1 += *(uint32_t*)(TPS_BASE + PPS1_SVT_DOUT);
		SVT_Dout2 += *(uint32_t*)(TPS_BASE + PPS2_SVT_DOUT);
		SVT_Dout3 += *(uint32_t*)(TPS_BASE + PPS3_SVT_DOUT);
		SVT_Dout4 += *(uint32_t*)(TPS_BASE + PPS4_SVT_DOUT);
		SVT_Dout5 += *(uint32_t*)(TPS_BASE + PPS5_SVT_DOUT);

		LVT_Dout0 += *(uint32_t*)(TPS_BASE + PPS0_LVT_DOUT);
		LVT_Dout1 += *(uint32_t*)(TPS_BASE + PPS1_LVT_DOUT);
		LVT_Dout2 += *(uint32_t*)(TPS_BASE + PPS2_LVT_DOUT);
		LVT_Dout3 += *(uint32_t*)(TPS_BASE + PPS3_LVT_DOUT);
		LVT_Dout4 += *(uint32_t*)(TPS_BASE + PPS4_LVT_DOUT);
		LVT_Dout5 += *(uint32_t*)(TPS_BASE + PPS5_LVT_DOUT);

		ULVT_Dout0 += *(uint32_t*)(TPS_BASE + PPS0_ULVT_DOUT);
		ULVT_Dout1 += *(uint32_t*)(TPS_BASE + PPS1_ULVT_DOUT);
		ULVT_Dout2 += *(uint32_t*)(TPS_BASE + PPS2_ULVT_DOUT);
		ULVT_Dout3 += *(uint32_t*)(TPS_BASE + PPS3_ULVT_DOUT);
		ULVT_Dout4 += *(uint32_t*)(TPS_BASE + PPS4_ULVT_DOUT);
		ULVT_Dout5 += *(uint32_t*)(TPS_BASE + PPS5_ULVT_DOUT);

		TPS_delay(100);
	}
	
	SVT_AVAout = (SVT_Dout0+SVT_Dout1+SVT_Dout2+SVT_Dout3+SVT_Dout4+SVT_Dout5)/600;
	LVT_AVAout = (LVT_Dout0+LVT_Dout1+LVT_Dout2+LVT_Dout3+LVT_Dout4+LVT_Dout5)/600;
	ULVT_AVAout = (ULVT_Dout0+ULVT_Dout1+ULVT_Dout2+ULVT_Dout3+ULVT_Dout4+ULVT_Dout5)/600;

	printf("SVT0 Read Data:%d \n",SVT_Dout0/100);
	printf("SVT1 Read Data:%d \n",SVT_Dout1/100);
	printf("SVT2 Read Data:%d \n",SVT_Dout2/100);
	printf("SVT3 Read Data:%d \n",SVT_Dout3/100);
	printf("SVT4 Read Data:%d \n",SVT_Dout4/100);
	printf("SVT5 Read Data:%d \n",SVT_Dout5/100);
	printf("SVT average Read Data:%d \n\n",SVT_AVAout);

	printf("LVT0 Read Data:%d \n",LVT_Dout0/100);
	printf("LVT1 Read Data:%d \n",LVT_Dout1/100);
	printf("LVT2 Read Data:%d \n",LVT_Dout2/100);
	printf("LVT3 Read Data:%d \n",LVT_Dout3/100);
	printf("LVT4 Read Data:%d \n",LVT_Dout4/100);
	printf("LVT5 Read Data:%d \n",LVT_Dout5/100);
	printf("LVT average Read Data:%d \n\n",LVT_AVAout);

	printf("ULVT0 Read Data:%d \n",ULVT_Dout0/100);
	printf("ULVT1 Read Data:%d \n",ULVT_Dout1/100);
	printf("ULVT2 Read Data:%d \n",ULVT_Dout2/100);
	printf("ULVT3 Read Data:%d \n",ULVT_Dout3/100);
	printf("ULVT4 Read Data:%d \n",ULVT_Dout4/100);
	printf("ULVT5 Read Data:%d \n",ULVT_Dout5/100);
	printf("ULVT average Read Data:%d \n\n",ULVT_AVAout);
}

