/** 
********************************************************************************
* @file       M6678E_WatchDog.c
* @brief      M6678EŹؽӿں
* @version    V1.0
* @date       2024.1.17
* @attention  
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include <stdio.h>
#include <stdlib.h>
#include <c6x.h>
#include "M6678E_WATCHDOG.h"

/** @addtogroup WatchDog_FUNCTION
 @{ */

/**
********************************************************************************
 *   @n@b WatchDog_Config(unsigned int WatchDog_Numb, unsigned int Step, unsigned int Counter,unsigned int Threshold,unsigned int Enable)
 *
 *   @b ܣ
 *   @n ÿŹ
 *
 *   @b βΣ
 *   @verbatim
 *       WatchDog_NumbΪŹĲţѡ0~11
 *       StepΪĴֵ
 *       CounterΪĴֵдκŹ
 *       ThresholdΪֵĴֵ
 *       EnableΪλʹܼĴֵѡ01, 1ʾŹλ0ʾŹλ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 1жϼ=Step*Threshold+1ʱ
 * 	    2ŹʱΪƵķƵ
 *******************************************************************************
 */
void WatchDog_Config(unsigned int WatchDog_Numb, unsigned int Step, unsigned int Counter,unsigned int Threshold,unsigned int Enable)
{
	*(volatile unsigned int*)(WatchDog_Step + WatchDog_Numb * 0x1000) = Step;
	*(volatile unsigned int*)(WatchDog_Threshold + WatchDog_Numb * 0x1000) = Threshold;
	*(volatile unsigned int*)(WatchDog_Counter + WatchDog_Numb * 0x1000) = Counter;
	*(volatile unsigned int*)(WatchDog_Enable + WatchDog_Numb * 0x1000) = Enable;
}
