/**
********************************************************************************
* @file       M6678E_IPC.h
* @brief      M6678E IPCֽӿںͼĴ궨塣
* @version    V1.0
* @date       2023.01.05
* @attention
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef _M6678E_IPC_H_
#define _M6678E_IPC_H_

#define IPCGR0        0x09000300
#define IPCGRH        0x09000360

#define IPCAR0        0x09000400
#define IPCARH        0x09000460

#define IPCG_ARM      0x09000380

#define IPCAR0        0x09000400
#define IPCARH        0x09000460
#define IPCA_ARM      0x09000480

extern void IPC_Send(unsigned int IPC_Numb , unsigned int IPC_SouceID);
extern void IPC_Send_ARM(unsigned int IPC_Numb , unsigned int IPC_SouceID);

extern unsigned int IPC_Src_Get(unsigned int IPC_Numb);
extern unsigned int IPC_Src_ARMCore(unsigned int CoreNumb);

extern void IPC_AR_Release(unsigned int IPC_Numb , unsigned int IPC_SouceID);
extern void IPC_AR_Release_ARMCore(unsigned int CoreNumb , unsigned int IPC_SouceID);

extern unsigned int IPC_AR_Src_DSPCore(unsigned int CoreNumb);
extern unsigned int IPC_AR_Src_ARMCore(unsigned int CoreNumb);

#endif /* _M6678E_IPC_H_ */
