/** 
********************************************************************************
* @file       M6678E_PSC.h
* @brief      M6678EʱӽӿںͼĴ궨塣
* @version    V1.0
* @date       2024/1/15
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef   _M6678E_PSC_H_
#define   _M6678E_PSC_H_

/***************PSC ӿں***************************************************/
extern void PSC_Open_Clk(const char *string , unsigned int Power_Domain);
extern void PSC_Close_Clk(const char *string , unsigned int Power_Domain);

/***************PSC Ĵ*******************************************************/
#define PSC_BASE            0x09080000
#define PTCMD_REG           0x09080120
#define PTSTAT_REG	        0x09080128

/***************PSC ģʱӼĴ**************************************************/

#define	DSP0CORE_offset		0xA04
#define DSP1CORE_offset    	0xA08
#define DSP2CORE_offset     0xA0C
#define DSP3CORE_offset     0xA10
#define DSP4CORE_offset     0xA14
#define DSP5CORE_offset    	0xA18
#define DSP6CORE_offset   	0xA1C
#define DSP7CORE_offset    	0xA20
//#define	ARMA15CORE_offset	0xA24

#define DSP0_offset    		0xA28
#define DSP1_offset    		0xA2C
#define DSP2_offset    		0xA30
#define DSP3_offset    		0xA34
#define DSP4_offset    		0xA38
#define DSP5_offset    		0xA3C
#define DSP6_offset    		0xA40
#define DSP7_offset    		0xA44
#define ARMA15_offset    	0xA48

#define	FFT_offset			0xA4C
#define	FFT1_offset			0xAA4
#define	PNNA_offset			0xA50
#define	RGMII_offset		0xA54
#define	PCIE_offset			0xA58

#define	SRIO0_offset		0xA5C
#define	SRIO1_offset		0xA60
#define	SRIO2_offset		0xA64
#define	TP_offset			0xA68

#define	SMC_offset			0xA6C
#define	EMIF_offset			0xA70
#define	DDR_offset			0xA74
#define	DMA0_offset			0xA78
#define	DMA1_offset			0xA7C
#define	DMA2_offset			0xA80
#define	DMA3_offset			0xA84
#define	DMA4_offset			0xA88
#define	GPIO_offset			0xA8C
#define	I2C_offset			0xA90
#define	SPI_offset			0xA94
#define	UART_offset			0xA98
#define	TIMER_offset		0xA9C
#define	M1553B_offset		0xAA0



#endif
