/** 
********************************************************************************
* @file       M6678E_Timer.h
* @brief      FT-M6678E TimerصĽӿں
* @version    V1.0
* @date       2024.1.17
* @attention  
* \par
* ============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#ifndef  _M6678E_Timer_H_
#define  _M6678E_Timer_H_

#define  TIMER_BASE            	0x08100000
#define  TOUTPSEL        		0x09000580



extern void Timer64_Config(unsigned int Numb,long long Period,unsigned int Mode);
extern void Timer32_Link_Config(unsigned int Numb,unsigned int PRDHI_Value,unsigned int PRDLO_Value,unsigned int Mode);
extern void Timer32_NOLink_TIMHI_Config(unsigned int Numb,unsigned int PSCHI_Value,unsigned int PRDHI_Value,unsigned int Mode);
extern void Timer32_NOLink_TIMLO_Config(unsigned int Numb,unsigned int PRDLO_Value,unsigned int Mode);
extern void Timer_Reload_Config(unsigned int Numb,unsigned int RELHI_Value,unsigned int RELLO_Value);
extern void Timer_End(unsigned int Numb);
extern void Timer_Out_Config(unsigned int Numb,unsigned int OutPutMode,unsigned int Polar);
extern int Timer_Start(unsigned int Numb);
extern void Timer_TimoSel(unsigned int Numb,unsigned int timo);
extern void Timer_EMUMGT_config(unsigned int Numb , unsigned int EMUMGT_Numb);

#endif   /*_M6678E_Timer_H_*/
