/*
*	M6678E TPS ļ
*	M6678E ʹõ¶ȴͺΪS14NSFPVT
*	¶ȲΧ-40~125
*
*	First Writer: WenJoy
*/
#ifndef  _M6678E_TSC_H_
#define  _M6678E_TSC_H_

#include <stdint.h>
#include <stdio.h>
#include <math.h>
#include "M6678E_I2C.h"

/***********TPS Base address define**********/
#define	TPS_BASE	0x08020000

/***********TPS Register offset define**********/
#define	TPS_TGATE	0x10	//0x00000FFF	¶ֵĴ
#define	TPS_INTEN	0x14	//0x00000	жʹܼĴ
#define	TPS_INSTATE	0x18	//0x00000	ж״̬Ĵ
#define	TPS_I2COAR	0x1C	//0x00000	¶ȴI2Cӿڵַ
#define	TPS0_MODE	0x100	//0x00009	0¶ȴ	TDC_Mode	ź
#define	TPS0_DOUT	0x104	//0x00000000	0¶ȴ¼¶ 0~11λЧ
#define	TPS0_TRIM	0x108	//0x00000000	0¶ȴ	TRIM	У׼
#define	TPS1_MODE	0x200	//0x00009	1¶ȴ	TDC_Mode	ź
#define	TPS1_DOUT	0x204	//0x00000	1¶ȴ¼¶
#define	TPS1_TRIM	0x208	//0x00000	1¶ȴ	TRIM	У׼
#define	TPS2_MODE	0x300	//0x00009	2¶ȴ	TDC_Mode	ź
#define	TPS2_DOUT	0x304	//0x00000	2¶ȴ¼¶
#define	TPS2_TRIM	0x308	//0x00000	2¶ȴ	TRIM	У׼
#define	TPS3_MODE	0x400	//0x00009	3¶ȴ	TDC_Mode	ź
#define	TPS3_DOUT	0x404	//0x00000000	3¶ȴ¼¶
#define	TPS3_TRIM	0x408	//0x00000000	3¶ȴ	TRIM	У׼
#define	TPS4_MODE	0x500	//0x00009	4¶ȴ	TDC_Mode	ź
#define	TPS4_DOUT	0x504	//0x00000	4¶ȴ¼¶
#define	TPS4_TRIM	0x508	//0x00000	4¶ȴ	TRIM	У׼
#define	TPS5_MODE	0x600	//0x00009	5¶ȴ	TDC_Mode	ź
#define	TPS5_DOUT	0x604	//0x00000	5¶ȴ¼¶
#define	TPS5_TRIM	0x608	//0x00000	5¶ȴ	TRIM	У׼

#define	PPS0_SVT_PU		0x1000	//0x00000	0ƫ	SVT	ϵź
#define	PPS0_SVT_RB		0x1004	//0x00000	0ƫ	SVT	λź
#define	PPS0_SVT_DOUT	0x1008	//0x00000	0ƫ	SVT	
#define	PPS0_LVT_PU		0x100C	//0x00000	0ƫ	LVT	ϵź
#define	PPS0_LVT_RB		0x1010	//0x00000	0ƫ	LVT	λź
#define	PPS0_LVT_DOUT	0x1014	//0x00000	0ƫ	LVT	
#define	PPS0_ULVT_PU	0x1018	//0x00000	0ƫ	ULVTϵź
#define	PPS0_ULVT_RB	0x101C	//0x00000	0ƫ	ULVTλź
#define	PPS0_ULVT_DOUT	0x1020	//0x00000	0ƫ	ULVT	
#define	PPS1_SVT_PU		0x1100	//0x00000	1ƫ	SVT	ϵź
#define	PPS1_SVT_RB		0x1104	//0x00000	1ƫ	SVT	λź
#define	PPS1_SVT_DOUT	0x1108	//0x00000	1ƫ	SVT	
#define	PPS1_LVT_PU		0x110C	//0x00000	1ƫ	LVT	ϵź
#define	PPS1_LVT_RB		0x1110	//0x00000	1ƫ	LVT	λź
#define	PPS1_LVT_DOUT	0x1114	//0x00000	1ƫ	LVT	
#define	PPS1_ULVT_PU	0x1118	//0x00000	1ƫ	ULVTϵź
#define	PPS1_ULVT_RB	0x111C	//0x00000	1ƫ	ULVTλź
#define	PPS1_ULVT_DOUT	0x1120	//0x00000	1ƫ	ULVT
#define	PPS2_SVT_PU		0x1200	//0x00000	2ƫ	SVT	ϵź
#define	PPS2_SVT_RB		0x1204	//0x00000	2ƫ	SVT	λź
#define	PPS2_SVT_DOUT	0x1208	//0x00000	2ƫ	SVT	
#define	PPS2_LVT_PU		0x120C	//0x00000	2ƫ	LVT	ϵź
#define	PPS2_LVT_RB		0x1210	//0x00000	2ƫ	LVT	λź
#define	PPS2_LVT_DOUT	0x1214	//0x00000	2ƫ	LVT	
#define	PPS2_ULVT_PU	0x1218	//0x00000	2ƫ	ULVTϵź
#define	PPS2_ULVT_RB	0x121C	//0x00000	2ƫ	ULVTλź
#define	PPS2_ULVT_DOUT	0x1220	//0x00000	2ƫ	ULVT	
#define	PPS3_SVT_PU		0x1300	//0x00000	3ƫ	SVT	ϵź
#define	PPS3_SVT_RB		0x1304	//0x00000	3ƫ	SVT	λź
#define	PPS3_SVT_DOUT	0x1308	//0x00000	3ƫ	SVT	
#define	PPS3_LVT_PU		0x130C	//0x00000	3ƫ	LVT	ϵź
#define	PPS3_LVT_RB		0x1310	//0x00000	3ƫ	LVT	λź
#define	PPS3_LVT_DOUT	0x1314	//0x00000	3ƫ	LVT	
#define	PPS3_ULVT_PU	0x1318	//0x00000	3ƫ	ULVT	ϵź
#define	PPS3_ULVT_RB	0x131C	//0x00000	3ƫ	ULVT	λź
#define	PPS3_ULVT_DOUT	0x1320	//0x00000	3ƫ	ULVT	
#define	PPS4_SVT_PU		0x1400	//0x00000	4ƫ	SVT	ϵź
#define	PPS4_SVT_RB		0x1404	//0x00000	4ƫ	SVT	λź
#define	PPS4_SVT_DOUT	0x1408	//0x00000	4ƫ	SVT	
#define	PPS4_LVT_PU		0x140C	//0x00000	4ƫ	LVT	ϵź
#define	PPS4_LVT_RB		0x1410	//0x00000	4ƫ	LVT	λź
#define	PPS4_LVT_DOUT	0x1414	//0x00000	4ƫ	LVT	
#define	PPS4_ULVT_PU	0x1418	//0x00000	4ƫ	ULVT	ϵź
#define	PPS4_ULVT_RB	0x141C	//0x00000	4ƫ	ULVT	λź
#define	PPS4_ULVT_DOUT	0x1420	//0x00000	4ƫ	ULVT	
#define	PPS5_SVT_PU		0x1500	//0x00000	5ƫ	SVT	ϵź
#define	PPS5_SVT_RB		0x1504	//0x00000	5ƫ	SVT	λź
#define	PPS5_SVT_DOUT	0x1508	//0x00000	5ƫ	SVT	
#define	PPS5_LVT_PU		0x150C	//0x00000	5ƫ	LVT	ϵź
#define	PPS5_LVT_RB		0x1510	//0x00000	5ƫ	LVT	λź
#define	PPS5_LVT_DOUT	0x1514	//0x00000	5ƫ	LVT	
#define	PPS5_ULVT_PU	0x1518	//0x00000	5ƫ	ULVT	ϵź
#define	PPS5_ULVT_RB	0x151C	//0x00000	5ƫ	ULVT	λź
#define	PPS5_ULVT_DOUT	0x1520	//0x00000	5ƫ	ULVT	

void PVT_Init(void);
void PVT_temperture_read(void);
void PVT_Alarm_Init(uint32_t Alarm_num);
void PVT_Alarm_check(void);
void PVT_FIX(uint32_t fix_num);

void PPS_Init(void);
void PPS_temperture_read(void);

void TPS_delay(uint32_t delay_time);
//void TPS_I2C_Write(I2C_TypeDef *I2C_Dev, uint8_t Slave_Address);

#endif
