/** 
********************************************************************************
* @file       M6678E_IDMA.c
* @brief      ʵM6678E IDMAĸֽӿں
* @version    V1.0
* @date       2022.07.26
* @attention  
* \par
* ==============================================================================
* @n   (C) DSP֧Ŷ.
********************************************************************************
*/
#include "M6678E_IDMA.h"

/** @addtogroup IDMA_FUNCTION
 @{ */


/**
********************************************************************************
 *   @n@b IDMA1_Config(unsigned int SOURCE , unsigned int DEST, unsigned int COUNT, unsigned int INT_Enable)
 *
 *   @b ܣ
 *   @n IDMA1亯
 *
 *   @b βΣ
 *   @verbatim
 *      SOURCE ԴַԴַĴ   32 ֽڶ룬Ĵĵ  5 λ̶Ϊ 0
 *      DEST ĿĵַĿĵַĴ   32 ֽڶ룬Ĵĵ  5 λ̶Ϊ 0
 *      COUNT ֽڳȣȱΪ4ֽڵ
 *      INT_Enable ɺǷжϡ0ʾжϣ1ʾжϡ
 *      Fill  ʾFillʹܡ
 *   @endverbatim
 *
 *   <b> ֵ </b>
 *   @n 
 *
 *   <b> ע </b>
 *   @n 
 *******************************************************************************
 */
void  IDMA1_Config(unsigned int SOURCE , unsigned int DEST, unsigned int COUNT, unsigned int INT_Enable , unsigned int Fill)
{
	IDMA1_SOURCE = SOURCE;
	IDMA1_DEST   = DEST;
	IDMA1_COUNT  = (COUNT |( INT_Enable << 28 ) |( Fill << 16 ));
	while((IDMA1_STAT & 0x3) !=  0  )
	{}
}
